//------------------  W e b   D a t a   G r i d  ----------------------
//							 
//                          version 2.0
//
//                Copyright 2003 Augusto Fiastrelli
//
//                   augustofiastrelli@libero.it
//
//---------------------------------------------------------------------

function Grid(params) {
	
	this.name=(params.name+""=="undefined") ? "WebDataGrid" : params.name;
	this.serverSide=(params.serverSide+""=="undefined") ? false : params.serverSide;

	this.ArrayFilter=params.ArrayFilter;
	this.ArrayGrid=params.ArrayGrid;
	this.ArraySort=params.ArraySort;
	this.buttonSize=(params.buttonSize+""=="undefined") ? 32 : params.buttonSize;
	this.canHelp=(params.canHelp+""=="undefined") ? false : params.canHelp;
	this.canReload=(params.canReload+""=="undefined") ? false : params.canReload;
	this.charInclusive=(params.charInclusive + ""=="undefined") ? "-" : params.charInclusive;
	this.dataUrl=(params.dataUrl+""=="undefined") ? (this.serverSide ? "php/data/data" + this.name + ".php" : "data/data" + this.name + ".txt") : params.dataUrl;
	this.debug=(params.debug+""=="undefined") ? false : params.debug;
	this.filterBgColor=(params.filterBgColor+""=="undefined") ? "#FFFFEF" : params.filterBgColor;
	this.filterFontStyle=(params.filterFontStyle+""=="undefined") ? "font-size:8pt;font-family:Verdana;" : params.filterFontStyle;
	this.firstDelay=(params.firstDelay+""=="undefined") ? 850 : params.firstDelay;
	this.firstSort=(params.firstSort+""=="undefined") ? (this.serverSide ? "A0" : "+ID") : params.firstSort;
	this.gridAttrib=(params.gridAttrib+""=="undefined") ? "" : params.gridAttrib;
	this.gridFontAttrib=(params.gridFontAttrib+""=="undefined") ? "SIZE=1 FACE=Verdana" : params.gridFontAttrib;
	this.gridFontColor=(params.gridFontColor+""=="undefined") ? "Black" : params.gridFontColor;
	this.gridFontStyle=(params.gridFontStyle+""=="undefined") ? "" : params.gridFontStyle;
	this.headerFontAttrib=(params.headerFontAttrib+""=="undefined") ? "SIZE=1 FACE=Verdana" : params.headerFontAttrib ;
	this.headerFontStyle=(params.headerFontStyle+""=="undefined") ? "" : params.headerFontStyle;
	this.height=(params.height+""=="undefined") ?  "300" : params.height;
	this.language=(params.language+""=="undefined") ? GetLang() : params.language;
	this.OnClickSpan=(params.OnClickSpan+""=="undefined") ? function() { return; } : params.OnClickSpan;
	if (this.canHelp) this.OnHelp=params.OnHelp;
	this.OnHide=(params.OnHide+""=="undefined") ? function() { return; } : params.OnHide;
	this.OnMouseOverSpan=(params.OnMouseOverSpan+""=="undefined") ? function() { return; } : params.OnMouseOverSpan;
	this.OnShow=(params.OnShow+""=="undefined") ? function() { return; } : params.OnShow;
	this.recPageSize=(params.recPageSize + ""=="undefined") ? 0 : params.recPageSize;
	this.rowMarkFontColor=(params.rowMarkFontColor + ""=="undefined") ? "White" : params.rowMarkFontColor;
	this.rowMarkFontStyle=(params.rowMarkFontStyle + ""=="undefined") ? this.gridFontStyle : params.rowMarkFontStyle;
	this.spMark=(params.rowMarkBgColor + ""=="undefined") ? "#336699" : params.rowMarkBgColor;
	this.spOver=(params.rowOverBgColor + ""=="undefined") ? "#C1FFC9" : params.rowOverBgColor;
	this.textQualifier=(params.textQualifier+""=="undefined") ? "'" : params.textQualifier;
	this.visible=(params.visible+""=="undefined") ? true : params.visible;
	this.width=(params.width+""=="undefined") ? "100%" : params.width;

	this.ArrayCriterions=new Array(this.ArrayFilter.length);
	this.ArrayOperators=new Array("=","<>",">",">=","<","<=");
	this.lang=new lang(this);
	this.filterServer="";	
	
	this.ApplyFilter = function(check) {
		if (!check) {
			this.ArrayMarkedRows=new Array();
			this.posingGrid=true;
			posingGrid=true;
			document.getElementById("tab"+this.name).focus();
			this.posingGrid=false;
			posingGrid=false;
		}
		var r1=document.getElementById("tab"+this.name).rows(1);
		var s="";
		for (var i=0;i<r1.cells.length;i++) {
			if (this.ArrayCriterions[i]==16 || ((this.ArrayFilter[i][1]=="D" || this.ArrayFilter[i][1]=="N") && this.ArrayFilter[i][0]==10)) { //empty
				if (this.serverSide) {
					if (s!="") s+="~";
					s+=i+"|"+"I";
				} else {
					if (s!="") s+=" & ";
					if (this.ArrayFilter[i][1]=="N")
						s+=this.ArrayFilter[i][0]+"=0";
					else if (this.ArrayFilter[i][1]=="D")
						s+=this.ArrayFilter[i][0]+'>"31/12/9999"';
					else
						s+=this.ArrayFilter[i][0]+'=""';
				}
			} else if (this.ArrayCriterions[i]==17 || ((this.ArrayFilter[i][1]=="N") && this.ArrayFilter[i][0]==11)) { //non empty
				if (this.serverSide) {
					if (s!="") s+="~";
					s+=i+"|"+"L";
				} else {
					if (s!="") s+=" & ";
					if (this.ArrayFilter[i][1]=="N")
						s+=this.ArrayFilter[i][0]+"<>0";
					else if (this.ArrayFilter[i][1]=="D")
						s+=this.ArrayFilter[i][0]+'<"31/12/9999"';
					else
						s+=this.ArrayFilter[i][0]+'<>""';
				}
			} else if (this.ArrayCriterions[i]==19)  { //true
				if (this.serverSide) {
					if (s!="") s+="~";
					s+=i+"|"+"M";
				} else {
					if (s!="") s+=" & ";
					s+=this.ArrayFilter[i][0]+"="+"true";
				}
			} else if (this.ArrayCriterions[i]==20)  { //false
				if (this.serverSide) {
					if (s!="") s+="~";
					s+=i+"|"+"N";
				} else {
					if (s!="") s+=" & ";
					s+=this.ArrayFilter[i][0]+"="+"false";
				}
			} else if (r1.childNodes[i].childNodes[0].value!="" && this.ArrayFilter[i][1]!="B") {
				if (this.serverSide) {
					if (s!="") s+="~";
				} else {
					if (s!="") s+=" & ";
				}
				if (this.ArrayCriterions[i]==6) { //included between
					var x=r1.childNodes[i].childNodes[0].value.indexOf(this.charInclusive);
					if (x==-1 && !check) {
						alert(this.lang.errorIncluded);
						r1.childNodes[i].childNodes[0].select();
						return;
					}
					if (this.serverSide)
						s+=i+"|6|"+r1.childNodes[i].childNodes[0].value.substr(0,x)+"|"+
						   r1.childNodes[i].childNodes[0].value.substr(x+1,r1.childNodes[i].childNodes[0].value.length-x-1);
					else if (this.ArrayFilter[i][1]=="D")
						s+=this.CompleteDateValue(this.ArrayFilter[i][0],r1.childNodes[i].childNodes[0].value.substr(0,x),3) 
						   + " & " + this.CompleteDateValue(this.ArrayFilter[i][0],r1.childNodes[i].childNodes[0].value.substr(x+1,r1.childNodes[i].childNodes[0].value.length-x-1),5);
					else if (this.ArrayFilter[i][1]=="S")
						s+=this.ArrayFilter[i][0] + '>=' + this.CheckFilterField(r1.childNodes[i].childNodes[0].value.substr(0,x),this.ArrayFilter[i][1]) +
						   ' & ' + this.ArrayFilter[i][0] + '<' + 
						   this.RemoveSmallerEqualBug(this.CheckFilterField(r1.childNodes[i].childNodes[0].value.substr(x+1,r1.childNodes[i].childNodes[0].value.length-x-1),"S"));
					else
						s+=this.ArrayFilter[i][0] + '>=' + this.CheckFilterField(r1.childNodes[i].childNodes[0].value.substr(0,x),this.ArrayFilter[i][1]) +
					       ' & ' + this.ArrayFilter[i][0] + '<=' + this.CheckFilterField(r1.childNodes[i].childNodes[0].value.substr(x+1,r1.childNodes[i].childNodes[0].value.length-x-1),this.ArrayFilter[i][1]);
				} else if (this.ArrayCriterions[i]==7) { //not included between
					var x=r1.childNodes[i].childNodes[0].value.indexOf(this.charInclusive);
					if (x==-1 && !check) {
						alert(this.lang.errorIncluded);
						r1.childNodes[i].childNodes[0].select();
						return;
					}
					if (this.serverSide)
						s+=i+"|7|"+r1.childNodes[i].childNodes[0].value.substr(0,x)+"|"+ 
						r1.childNodes[i].childNodes[0].value.substr(x+1,r1.childNodes[i].childNodes[0].value.length-x-1);
					else if (this.ArrayFilter[i][1]=="D")
						s+=this.CompleteDateValue(this.ArrayFilter[i][0],r1.childNodes[i].childNodes[0].value.substr(0,x),4) 
						   + " & " + this.CompleteDateValue(this.ArrayFilter[i][0],r1.childNodes[i].childNodes[0].value.substr(x+1,r1.childNodes[i].childNodes[0].value.length-x-1),2);
					else
						s+="("+this.ArrayFilter[i][0] + '<' + this.CheckFilterField(r1.childNodes[i].childNodes[0].value.substr(0,x),this.ArrayFilter[i][1]) +
						   ' | ' + this.ArrayFilter[i][0] + '>' + 
						   this.CheckFilterField(r1.childNodes[i].childNodes[0].value.substr(x+1,r1.childNodes[i].childNodes[0].value.length-x-1),this.ArrayFilter[i][1]) + ')';
				} else if (this.ArrayCriterions[i]==8 || this.ArrayCriterions[i]==9) { //on the list, not on the list
					var x=r1.childNodes[i].childNodes[0].value.split(this.charInclusive);
					if (this.serverSide) {
						s+=i+"|"+this.ArrayCriterions[i];
						for (var c=0;c<x.length;c++)
							s+="|"+x[c];
					} else {
						if (this.ArrayCriterions[i]==8) s+="(";
						for (var c=0;c<x.length;c++) {
							if (c!=0)
								if (this.ArrayCriterions[i]==8)
									s+=" | ";
								else
									s+=" & ";
							if (this.ArrayFilter[i][1]=="D") {
								var p=(this.ArrayCriterions[i]==8) ? 0 : 1;
								if (this.ArrayCriterions[i]==8) s+="(";
								s+=this.CompleteDateValue(this.ArrayFilter[i][0],x[c],p);
								if (this.ArrayCriterions[i]==8) s+=")";
							} else {
								s+=this.ArrayFilter[i][0];
								if (this.ArrayCriterions[i]==8)
									s+="=";
								else
									s+="<>";
								s+=this.CheckFilterField(x[c],this.ArrayFilter[i][1]);
							}
						}
						if (this.ArrayCriterions[i]==8) s+=")";
					}
				} else {
					var c=(this.ArrayCriterions[i]+""=="undefined") ? 0 : this.ArrayCriterions[i];
					if (this.serverSide) {
					   if (c>9) c=String.fromCharCode(55+c);
					   s+=i+"|"+c+"|"+ r1.childNodes[i].childNodes[0].value;
					} else if (this.ArrayCriterions[i]>=0 && this.ArrayCriterions[i]<=5 || this.ArrayCriterions[i]+""=="undefined") { //equal, different, greater, greater equal, smaller, smaller equal
					   if (this.ArrayFilter[i][1]=="D")
						   s+=this.CompleteDateValue(this.ArrayFilter[i][0],r1.childNodes[i].childNodes[0].value,c);
					   else {
						   s+=this.ArrayFilter[i][0];
						   if (this.ArrayCriterions[i]==5 && this.ArrayFilter[i][1]=="S") //smaller equal
								s+="<" + this.RemoveSmallerEqualBug(this.CheckFilterField(r1.childNodes[i].childNodes[0].value,"S"));
						   else
								s+=this.ArrayOperators[c] + this.CheckFilterField(r1.childNodes[i].childNodes[0].value,this.ArrayFilter[i][1]);
					   }
					} else if (this.ArrayCriterions[i]==10)  { //starts with
						s+=this.ArrayFilter[i][0]+'="'+r1.childNodes[i].childNodes[0].value+'*"';
					} else if (this.ArrayCriterions[i]==11)  { //doesn't start with
						s+=this.ArrayFilter[i][0]+'<>"'+r1.childNodes[i].childNodes[0].value+'*"';
					} else if (this.ArrayCriterions[i]==12)  { //ends with
						s+=this.ArrayFilter[i][0]+'="*'+r1.childNodes[i].childNodes[0].value+'"';
					} else if (this.ArrayCriterions[i]==13)  { //doesn't end with
						s+=this.ArrayFilter[i][0]+'<>"*'+r1.childNodes[i].childNodes[0].value+'"';
					} else if (this.ArrayCriterions[i]==14)  { //contains
						s+=this.ArrayFilter[i][0]+'="*'+r1.childNodes[i].childNodes[0].value+'*"';
					} else if (this.ArrayCriterions[i]==15)  { //doesn't contain
						s+=this.ArrayFilter[i][0]+'<>"*'+r1.childNodes[i].childNodes[0].value+'*"';
					}
				}
			}
		}
		if (check) 
			if (this.serverSide)
				return (s!="" && s!=this.filterServer);
			else
				return (s!="" && s!=document.getElementById("rs"+this.name).Filter);
		if (s=="") return;
		this.Toolbar.enable("AvoidFilter");
		this.lastMouseOver=null;
		if (this.serverSide) {
			this.filterServer=s;
			this.ReloadData(0);
		} else {
			this.page=0;
			document.getElementById("rs"+this.name).Filter=s;
			document.getElementById("rs"+this.name).Reset();
			setTimeout(this.name + ".ChangePage(-3,0)",500);
		}
	}
	
	this.AvoidFilter = function() {
		this.lastMouseOver=null;
		this.ArrayMarkedRows=new Array();
		this.posingGrid=true;
		posingGrid=true;
		document.getElementById("tab"+this.name).focus();
		this.posingGrid=false;
		posingGrid=false;
		this.Toolbar.disable("AvoidFilter");
		if (this.serverSide) {
			this.filterServer="";
			this.ReloadData(0);
		} else {
			this.page=0;
			document.getElementById("rs"+this.name).Filter="";
			document.getElementById("rs"+this.name).Reset();
			setTimeout(this.name + ".ChangePage(-3,0)",500);
		}
	}

	this.ChangeLanguage = function(l) {
		this.ArrayGrid=eval(l+"ArrayGrid"+this.name);
		this.language=l;
		this.lang=new lang(this);
		this.RewriteGrid();
	}

	this.ChangePage = function(pag,index,reload) {
		if (pag==-1) return;
		if (document.getElementById("div" + this.name+"All").style.display=="none") {
			setTimeout(this.name+".ChangePage("+pag+","+index+","+reload+")",500);
			return;
		}
		var lastPag=this.GetLastPageNum();
		if (pag>lastPag) return;
		if (pag==-2) {
			pag=lastPag;
		}
		if (this.page==pag) return;
		if (pag==-3) pag=0;
		this.firstRowSel=(index+""!="undefined" && index!=-1) ? index : this.GetSelectedRowIndex(this.page,pag);
		if (this.serverSide && reload) {
			this.ReloadData(pag,true);
		} else {
			if (this.page<pag)
				for (var i=this.page;i<pag;i++)
					document.getElementById("tab" + this.name).nextPage();		
			else if (this.page>pag)
				for (var i=pag;i<this.page;i++)
					document.getElementById("tab" + this.name).previousPage();		
			this.page=pag;
			if (document.getElementById("rs" + this.name).recordset.recordCount>0 && !this.serverSide) {
				if (!(pag==0 && index==0 && this.lastMouseOver!=null)) this.lastMouseOver=null;
				this.SetMarkedRows();
				if (this.lastMouseOver!=null) this.lastMouseOver.title="";
			}
		}
		if (this.tableInDiv+""=="undefined") 
			this.SetTableInDiv();
		if (this.recPageSize!=0) {
			this.SetButtonStateNextPrevious(pag,lastPag,true);
		}
		this.posingGrid=true;
		posingGrid=true;
		document.getElementById("tab"+this.name).focus();
		this.posingGrid=false;
		posingGrid=false;
		this.ScrollInto();
	}

	this.ChangeRecPageSize = function() {
		if (isNaN(document.getElementById(this.name+"InputPageSize").value) || document.getElementById(this.name+"InputPageSize").value<0) {
			if (this.language=="it")
				alert('Il valore per impostare il recordset pagesize deve essere un numero maggiore o uguale a zero');
			else
				alert('Value to plan recordset pagesize must be greater or equal to zero');
			document.getElementById(this.name+"InputPageSize").select;
			return;
		}
		this.recPageSize=document.getElementById(this.name+"InputPageSize").value;
		document.getElementById("bar"+this.name).innerHTML=this.WriteBar(false,true);
		if (this.recPageSize==0)
			this.ReloadData(0);
		else
			this.ChangePage(-3,-1,true);
		if (document.getElementById("tab"+this.name).rows(1).style.display=="")
			this.Toolbar.press("PlanFilter");
		
	}

	this.CheckFilterField = function(val,type) {
		if (type=="S" && !this.serverSide)
			return '"'+val+'"';
		else
			return val;
	}

	this.CheckFilterPresent = function() {
		if (this.ApplyFilter(true))
			this.Toolbar.enable("ApplyFilter");
		else
			this.Toolbar.disable("ApplyFilter");
	}

	this.CheckTabKey = function() {
		if (event.keyCode==40) { //down key
			this.Move("down");
		} else if (event.keyCode==38) { //up key
			this.Move("up");
		}
	}

	this.ClickCheck = function(ele) {
		if (this.filterVisible) {
			if (ele.tagName=="TR") return;
			document.getElementById("rs"+this.name).recordset.MoveFirst();
			document.getElementById("rs"+this.name).recordset.Move(ele.parentNode.parentNode.rowIndex-2);
			var i=ele.parentNode.id.substr(("td"+this.name).length);
			if (document.getElementById("rs"+this.name).recordset(this.ArrayFilter[i][0].toString()).value) {
				document.getElementById("tab"+this.name).rows(1).childNodes[i].childNodes[0].innerText=this.lang.criterionTrue;
				this.ArrayCriterions[i]=19;
			} else {
				document.getElementById("tab"+this.name).rows(1).childNodes[i].childNodes[0].innerText=this.lang.criterionFalse;
				this.ArrayCriterions[i]=20;
			}
		}
	}

	this.ClickImg = function(ele) {
		if (this.filterVisible) {
			if (ele.tagName=="TR") return;
			document.getElementById("rs"+this.name).recordset.MoveFirst();
			document.getElementById("rs"+this.name).recordset.Move(ele.parentNode.parentNode.rowIndex-2);
			var i=ele.parentNode.id.substr(("td"+this.name).length);
			document.getElementById("tab"+this.name).rows(1).childNodes[i].childNodes[0].value+=document.getElementById("rs"+this.name).recordset(this.ArrayFilter[i][0].toString());
		}
	}

	this.ClickSpan = function(ele) {
		if (this.filterVisible) {
			if (ele.tagName=="TR") return;
			document.getElementById("rs"+this.name).recordset.MoveFirst();
			if (this.serverSide)
				document.getElementById("rs"+this.name).recordset.Move(ele.parentNode.parentNode.parentNode.rowIndex-2);
			else
				document.getElementById("rs"+this.name).recordset.Move(ele.parentNode.parentNode.parentNode.rowIndex-2+this.page*this.recPageSize);
			var i=ele.parentNode.parentNode.id.substr(("td"+this.name).length);
			if (this.ArrayFilter[i][1]=="N")
				document.getElementById("tab"+this.name).rows(1).childNodes[i].childNodes[0].value+=new String(document.getElementById("rs"+this.name).recordset(this.ArrayFilter[i][0].toString())).replace(".",",");
			else if (this.ArrayFilter[i][1]=="D") {
				var d=new Date(document.getElementById("rs"+this.name).recordset(this.ArrayFilter[i][0].toString()));	
				document.getElementById("tab"+this.name).rows(1).childNodes[i].childNodes[0].value+=d.getDate() + "/" + (d.getMonth() +1)+ "/" + d.getFullYear() + " " + d.getHours() +":"+d.getMinutes()+":"+d.getSeconds();
			} else
				document.getElementById("tab"+this.name).rows(1).childNodes[i].childNodes[0].value+=document.getElementById("rs"+this.name).recordset(this.ArrayFilter[i][0].toString());
		}
	}

	this.ClickTr = function(ele) {
		if (this.filterVisible && event.srcElement.tagName=='SPAN') return;
		if (event.srcElement.tagName=='SPAN' || event.srcElement.tagName=='TD') {
			var index=ele.rowIndex;
			if (this.recPageSize!=0) index+=this.page*this.recPageSize;
			var inarr=InArray(this.ArrayMarkedRows,index);
			if (inarr==-1) {
				this.MarkRow(ele,true);
				this.ArrayMarkedRows.push(index);
			} else {
				this.MarkRow(ele,false);
				this.ArrayMarkedRows.splice(inarr,1);
			}

		}
	}
	
	this.Client2ServerSort = function(field) {
		var ar=field.split(";");
		var s="";
		for (var i=0;i<ar.length;i++) {
			if (s!="") s+=",";
			if (ar[i].toString().charAt(0)=="+")
				s+="A"+InArray(this.ArraySort,ar[i].toString().substr(1,ar[i].toString().length),0);
			else
				s+="D"+InArray(this.ArraySort,ar[i].toString().substr(1,ar[i].toString().length),1);
		}
		return s;
	}

	this.CompleteDateValue = function(field,date,criterion) {
		date=date.replace("\\","/").replace(".",":");
		if (date.indexOf("/")==-1) { //only the year is specified
			if (criterion==0) //equal
				return field + '>="1/1/'+date+' 00:00:00" & '+field+'<="31/12/'+date+' 23:59:59"';
			else if (criterion==1) //different
				return "(" + field + '<"1/1/'+date+' 00:00:00" | '+field+'>"31/12/'+date+' 23:59:59")';
			else if (criterion==2 || criterion==5) //bigger, smaller equal
				return field+this.ArrayOperators[criterion]+'"31/12/'+date+' 23:59:59"';
			else if (criterion==3 || criterion==4) //bigger equal, smaller
				return field+this.ArrayOperators[criterion]+'"1/1/'+date+' 00:00:00"';
		} else if (date.indexOf("/")==date.lastIndexOf("/")) { // month/year are specified
			var days=this.GetDaysInMonth(date.substr(0,date.indexOf("/")),date.substr(date.indexOf("/")+1));
			if (criterion==0) //equal
				return field + '>="1/'+date+' 00:00:00" & '+field+'<="'+days+'/'+date+' 23:59:59"';
			else if (criterion==1) //different
				return "(" + field + '<"1/'+date+' 00:00:00" | '+field+'>"'+days+'/'+date+' 23:59:59")';
			else if (criterion==2 || criterion==5) //bigger, smaller equal
				return field+this.ArrayOperators[criterion]+'"'+days+'/'+date+' 23:59:59"';
			else if (criterion==3 || criterion==4) //bigger equal, smaller
				return field+this.ArrayOperators[criterion]+'"1/'+date+' 00:00:00"';
		} else if (date.indexOf(" ")==-1) { // day/month/year are specified
			if (criterion==0) //equal
				return field + '>="'+date+' 00:00:00" & '+field+'<="'+date+' 23:59:59"';
			else if (criterion==1) //different
				return "(" + field + '<"'+date+' 00:00:00" | '+field+'>"'+date+' 23:59:59")';
			else if (criterion==2 || criterion==5) //bigger, smaller equal
				return field+this.ArrayOperators[criterion]+'"'+date+' 23:59:59"';
			else if (criterion==3 || criterion==4) //bigger equal, smaller
				return field+this.ArrayOperators[criterion]+'"'+date+' 00:00:00"';
		} else if (date.indexOf(":")==-1) { // day/month/year hour are specified
			if (criterion==0) //equal
				return field + '>="'+date+':00:00" & '+field+'<="'+date+':59:59"';
			else if (criterion==1) //different
				return "(" + field + '<"'+date+':00:00" | '+field+'>"'+date+':59:59")';
			else if (criterion==2 || criterion==5) //bigger, smaller equal
				return field+this.ArrayOperators[criterion]+'"'+date+':59:59"';
			else if (criterion==3 || criterion==4) //bigger equal, smaller
				return field+this.ArrayOperators[criterion]+'"'+date+':00:00"';
		} else if (date.indexOf(":")==date.lastIndexOf(":") && date.indexOf(":")!=-1 && date.lastIndexOf(":")!=-1) { // day/month/year hour:minute are specified
			if (criterion==0) //equal
				return field + '>="'+date+':00" & '+field+'<="'+date+':59"';
			else if (criterion==1) //different
				return "(" + field + '<"'+date+':00" | '+field+'>"'+date+':59")';
			else if (criterion==2 || criterion==5) //bigger, smaller equal
				return field+this.ArrayOperators[criterion]+'"'+date+':59"';
			else if (criterion==3 || criterion==4) //bigger equal, smaller
				return field+this.ArrayOperators[criterion]+'"'+date+':00"';
		}
		//a complete datetime value is specified
		return field+this.ArrayOperators[criterion]+'"'+date+'"';
	}

	this.DblclickTd = function(col) {
		this.lastFilterCol=col;
		this.FillPopUp(this.ArrayCriterions[col],this.ArrayFilter[col][1]);
		document.getElementById("popUpFilterCriterion"+this.name).PopUp();
	}

	this.FillPopUp = function(condition,type) {
		var i=(condition+""=="undefined")? (type=="B") ? 18 : 0 : condition;
		var schr="\t"+String.fromCharCode(171);
		var criterion;
		document.getElementById("popUpFilterCriterion" + this.name).Clear();
		if (type!="B") {
			criterion=this.lang.criterionEqual;
			if (i==0) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionDifferent;
			if (i==1) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionBigger;
			if (i==2) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionBiggerUguale;
			if (i==3) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionSmaller;
			if (i==4) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionSmallerUguale;
			if (i==5) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionIncluded;
			if (i==6) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionNotIncluded;
			if (i==7) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionOnTheList;
			if (i==8) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionNotOnTheList;
			if (i==9) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);

		}
		if (type=="N" || type=="D") {
			criterion=this.lang.criterionEmpty;
			if (i==10 || i==16) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionNotEmpty;
			if (i==11 || i==17) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
		}
		if (type=="S") {
			criterion=this.lang.criterionStarts;
			if (i==10) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionNotStarts;
			if (i==11) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionEnds;
			if (i==12) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionNotEnds;
			if (i==13) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionContains;
			if (i==14) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionNotContains;
			if (i==15) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionEmpty;
			if (i==16) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionNotEmpty;
			if (i==17) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
		}
		if (type=="B") {
			criterion=this.lang.criterionNoOne;
			if (i==18) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			document.getElementById("popUpFilterCriterion" + this.name).AddItem("");
			criterion=this.lang.criterionTrue;
			if (i==19) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
			criterion=this.lang.criterionFalse;
			if (i==20) criterion += schr;
			document.getElementById("popUpFilterCriterion" + this.name).AddItem(criterion);
		}
	}

	this.GetCaptionCondizione = function(val) {
		if (val==0)
			return this.lang.criterionEqual;
		if (val==1)
			return this.lang.criterionDifferent;
		if (val==2)
			return this.lang.criterionBigger;
		if (val==3)
			return this.lang.criterionBiggerUguale;
		if (val==4)
			return this.lang.criterionSmaller;
		if (val==5)
			return this.lang.criterionSmallerUguale;
		if (val==6)
			return this.lang.criterionIncluded;
		if (val==7)
			return this.lang.criterionNotIncluded;
		if (val==8)
			return this.lang.criterionOnTheList;
		if (val==9)
			return this.lang.criterionNotOnTheList;
		if (val==10)
			return this.lang.criterionStarts;
		if (val==11)
			return this.lang.criterionNotStarts;
		if (val==12)
			return this.lang.criterionEnds;
		if (val==13)
			return this.lang.criterionNotEnds;
		if (val==14)
			return this.lang.criterionContains;
		if (val==15)
			return this.lang.criterionNotContains;
		if (val==16)
			return this.lang.criterionEmpty;
		if (val==17)
			return this.lang.criterionNotEmpty;
		if (val==18)
			return this.lang.criterionNoOne;
		if (val==19)
			return this.lang.criterionTrue;
		if (val==20)
			return this.lang.criterionFalse;
	}

	this.GetDaysInMonth = function(month,year) {
		if (month==2) { 
			if ( (year % 4)==0 )
				return 29;
			return 28;
		}
		if (month==1 || month==3 || month==5 || month==7 || month==8 || month==10 || month==12 )
			return 31;
		return 30;
	}

	this.GetLastPageNum = function() {
		if (this.recPageSize==0) return 0;
		var lastPage;
		if (this.filterServer!="") {
			lastPag=Math.floor(eval(this.name+'RecordCountFilter.document.body.outerText')/this.recPageSize)-1;
			if (Number(eval(this.name+'RecordCountFilter.document.body.outerText'))%this.recPageSize!=0) { 
				lastPag++;
			} 
		} else if (this.serverSide) {
			lastPag=Math.floor(this.recordCount/this.recPageSize)-1;
			if (this.recordCount%this.recPageSize!=0) { 
				lastPag++;
			}
		} else {
			lastPag=Math.floor(document.getElementById("rs"+this.name).recordset.recordCount/this.recPageSize)-1;
			if (document.getElementById("rs"+this.name).recordset.recordCount%this.recPageSize!=0) { 
				lastPag++;
			} 
		}
		return lastPag;
	}

	this.GetLastRowNum = function() {
		if (this.filterServer!="") {
			if (this.recPageSize==0 || this.recPageSize > Number(eval(this.name+'RecordCountFilter.document.body.outerText')))
				return Number(eval(this.name+'RecordCountFilter.document.body.outerText'));
			else
				return Number(eval(this.name+'RecordCountFilter.document.body.outerText'))-this.recPageSize*this.GetLastPageNum();
		} else {
			if (this.recPageSize==0 || this.recPageSize > this.recordCount)
				return this.recordCount;
			else
				return this.recordCount-this.recPageSize*this.GetLastPageNum();
		}
	}

	this.GetSelectedRowIndex = function(oldPage,newPage) {
		return (oldPage>newPage && this.tableInDiv) ? this.recPageSize-1 : 0;
	}

	this.GetItemDataCondition = function(val) {
		if (val==this.lang.criterionEqual)
			return 0;
		if (val==this.lang.criterionDifferent)
			return 1;
		if (val==this.lang.criterionBigger)
			return 2;
		if (val==this.lang.criterionBiggerUguale)
			return 3;
		if (val==this.lang.criterionSmaller)
			return 4;
		if (val==this.lang.criterionSmallerUguale)
			return 5;
		if (val==this.lang.criterionIncluded)
			return 6;
		if (val==this.lang.criterionNotIncluded)
			return 7;
		if (val==this.lang.criterionOnTheList)
			return 8;
		if (val==this.lang.criterionNotOnTheList)
			return 9;
		if (val==this.lang.criterionStarts)
			return 10;
		if (val==this.lang.criterionNotStarts)
			return 11;
		if (val==this.lang.criterionEnds)
			return 12;
		if (val==this.lang.criterionNotEnds)
			return 13;
		if (val==this.lang.criterionContains)
			return 14;
		if (val==this.lang.criterionNotContains)
			return 15;
		if (val==this.lang.criterionEmpty)
			return 16;
		if (val==this.lang.criterionNotEmpty)
			return 17;
		if (val==this.lang.criterionNoOne)
			return 18;
		if (val==this.lang.criterionTrue)
			return 19;
		if (val==this.lang.criterionFalse)
			return 20;
	}	

	this.Hide = function() {
		document.getElementById("div"+this.name+"All").style.display="none";
		document.getElementById("div"+this.name).style.display="none";
		document.getElementById("tab"+this.name).style.display="none";
		this.visible=false;
		clearInterval(this.intervalFilterPresent);
		this.OnHide();
	}

	this.KeyPressFilter = function() {
		if (event.keyCode==13)
			this.ApplyFilter();
	}

	this.MarkRow = function(ele,mark) {
		for (var i=0;i<ele.childNodes.length;i++) {
			if (!mark) {
				if (this.ArrayGrid[i][8]+""=="undefined" || this.ArrayGrid[i][8]==null)
					ele.childNodes[i].childNodes[0].color=this.gridFontColor;
				else
					ele.childNodes[i].childNodes[0].color=this.ArrayGrid[i][8];
				if (this.ArrayGrid[i][9]+""=="undefined" || this.ArrayGrid[i][9]==null)
					ele.childNodes[i].childNodes[0].style.cssText=this.gridFontStyle;
				else
					ele.childNodes[i].childNodes[0].style.cssText=this.ArrayGrid[i][9];
			} else {
				if (this.ArrayGrid[i][10]+""=="undefined" || this.ArrayGrid[i][10]==null)
					ele.childNodes[i].childNodes[0].color=this.rowMarkFontColor;
				else
					ele.childNodes[i].childNodes[0].color=this.ArrayGrid[i][10];
				if (this.ArrayGrid[i][11]+""=="undefined"  || this.ArrayGrid[i][11]==null)
					ele.childNodes[i].childNodes[0].style.cssText=this.rowMarkFontStyle;	
				else
					ele.childNodes[i].childNodes[0].style.cssText=this.ArrayGrid[i][11];

			}
		}
		setPointer(ele, 'click', '#FFFFFF', this.spOver , this.spMark,'#FFFFFF','#000000');
		if (!this.serverSide && !mark)
			setPointer(ele, 'out', '#FFFFFF', this.spOver , this.spMark,'#FFFFFF','#000000');
	}

	this.MouseDownTh = function(index) {
		if (event.button==1)  { //left key
			this.Sort(index,true);
		} else { //right key
			this.Sort(index);
		}
	}

	this.MouseOverSpan = function(ele) {
		if (this.filterVisible)
			ele.style.cursor="auto";
		else
			if (this.ArrayGrid[InArray(this.ArrayGrid,ele.dataFld,1)][2].charAt(1)=="L")
				ele.style.cursor="hand";
	}

	this.MouseOverTr = function(ele,check) {
		if (!this.visible) return;
		var changeTitle=true;
		if (!CheckMouseOver()) {
			if (check)
				return;
			else {
				if (this.lastMouseOver!=null) this.lastMouseOver.title="";
				changeTitle=false;
			}
		}
		if (this.lastMouseOver!=null) {
			setPointer(this.lastMouseOver, 'out', '#FFFFFF', this.spOver, this.spMark);
		}
		this.lastMouseOver=ele;
		if (!setPointer(ele, 'over', '#FFFFFF', this.spOver, this.spMark)) {
			setTimeout(this.name+".MouseOverTr("+ele+","+check+")",500);
			return;
		}
		if (changeTitle) {
			if (this.serverSide) {
				this.lastMouseOver.title=this.lang.recCurrent+": "+(ele.rowIndex-1+this.page*this.recPageSize);
				if (this.filterServer!="")
					ele.title+="\n"+this.lang.recFiltered+": "+eval(this.name+'RecordCountFilter.document.body.outerText');
				this.lastMouseOver.title+="\n"+this.lang.recTotals+": "+this.recordCount;
			} else {
				this.lastMouseOver.title=this.lang.recCurrent+": "+(ele.rowIndex-1+this.page*this.recPageSize);
				if (document.getElementById("rs"+this.name).Filter!="")
					ele.title+="\n"+this.lang.recFiltered+": "+document.getElementById("rs"+this.name).recordset.recordCount;
				this.lastMouseOver.title+="\n"+this.lang.recTotals+": "+this.recordCount;
			}
		}
	}

	this.Move = function(direction) {
		if (this.lastMouseOver==null) return;
		this.lastMouseOver.title="";
		var lastPage=this.GetLastPageNum();
		if (direction=="down") {
			if (this.page==lastPage && this.lastMouseOver.rowIndex-1==this.GetLastRowNum()) return;
			if (this.lastMouseOver!=null) setPointer(this.lastMouseOver, 'out', '#FFFFFF', this.spOver, this.spMark);
			if (this.lastMouseOver==null || this.lastMouseOver.rowIndex-1==this.recPageSize) {
				if (!this.serverSide) this.lastMouseOver=null;
				this.ChangePage(this.page+1,-1,this.serverSide);
				if (this.serverSide) this.lastMouseOver=null;
			} else {
				this.lastMouseOver=document.getElementById("tab"+this.name).rows(this.lastMouseOver.rowIndex+1);
				setPointer(this.lastMouseOver, 'over', '#FFFFFF', this.spOver, this.spMark);
			}
		} else if (direction=="up") {
			if (this.page==0 && this.lastMouseOver.rowIndex==2) return;
			if (this.lastMouseOver!=null) setPointer(this.lastMouseOver, 'out', '#FFFFFF', this.spOver, this.spMark);
			if (this.lastMouseOver.rowIndex==2) {
				if (!this.serverSide) this.lastMouseOver=null;
				this.ChangePage(this.page-1,-1,this.serverSide);
				if (this.serverSide) this.lastMouseOver=null;
			} else {
				this.lastMouseOver=document.getElementById("tab"+this.name).rows(this.lastMouseOver.rowIndex-1);
				setPointer(this.lastMouseOver, 'over', '#FFFFFF', this.spOver, this.spMark);
			}
		}
	}

	this.NoContext = function() {
		event.cancelBubble=true;
		event.returnValue=false;
		return false;
	}

	this.OnDataLoad = function() {
		if (this.nostart+""=="undefined" || !this.nostart)
			this.Start();
		this.ScrollInto();
	}

	this.OnDataReload = function() {
		if (!this.visible) {
			setTimeout(this.name+".OnDataReload()",this.firstDelay);
			return;
		}
		if (this.canReload) this.Toolbar.enable("Update");
		this.Resize();
		if (this.page==0) this.SetTableInDiv();
		document.getElementById("div"+this.name+"All").scrollIntoView(true);
		if (document.getElementById("tab"+this.name).rows.length>2)
			this.SetMarkedRows();
		this.intervalFilterPresent=setInterval(this.name+".CheckFilterPresent()",1000);

	}

	this.PlanFilter = function() {
		this.posingGrid=true;
		posingGrid=true;
		document.getElementById("tab"+this.name).focus();
		this.posingGrid=false;
		posingGrid=false;
		var r1=document.getElementById("tab"+this.name).rows(1);
		if (r1.style.display=="") {
			this.filterVisible=false;
		} else {
			this.filterVisible=true;
			var r0=document.getElementById("tab"+this.name).rows(0);
			for (var i=0;i<r1.cells.length;i++)
				r1.childNodes[i].childNodes[0].width=r0.childNodes[i].offsetWidth-12;
		}
		this.Resize(this.filterVisible);
		this.ScrollInto();
	}

	this.PlanSortHeaders = function() {
		var ar;
		if (this.serverSide) {
			ar=this.sortServer.split(",");
		} else
			ar=document.getElementById("rs"+this.name).Sort.split(";");
		for (var i=0;i<this.ArraySort.length;i++) {
			document.getElementById("divSortNum"+this.name+this.ArraySort[i][0].toString()).style.display="none";
			var q;
			if (this.serverSide) {
				q=InArray(ar,"A"+i);
			} else 
				q=InArray(ar,"+"+this.ArraySort[i][0]);
			var d="+";
			if (q==-1) {
				if (this.serverSide)
					q=InArray(ar,"D"+i);
				else
					q=InArray(ar,"-"+this.ArraySort[i][1]);
				d="-";
			}
			if (q==-1) {
				document.getElementById("img"+this.name+this.ArraySort[i][0].toString()).src=imgWhite.src;
			} else {
				if (d=="+")
					document.getElementById("img"+this.name+this.ArraySort[i][0].toString()).src=imgUp.src;
				else
					document.getElementById("img"+this.name+this.ArraySort[i][0].toString()).src=imgDown.src;
				if (q!=0) {
					var t='<FONT SIZE=0 FACE=Verdana '+this.headerFontAttrib+' STYLE="'+this.headerFontStyle+'">'+(q+1)+'</FONT>';
					document.getElementById("divSortNum"+this.name+this.ArraySort[i][0].toString()).innerHTML=t;
					document.getElementById("divSortNum"+this.name+this.ArraySort[i][0].toString()).style.display="";
				}
			}
		}
	}

	this.ReloadData = function(pag,nostart) {
		document.getElementById("rs"+this.name).DataURL=this.dataUrl;
		if (this.serverSide )
			document.getElementById("rs"+this.name).DataURL+="?P="+pag+"&S="+this.recPageSize;
		if (this.filterServer!="") {
			eval(this.name+"RecordCountFilter.location.replace('')");
			eval(this.name+"RecordCountFilter.location.replace('"+this.dataUrl+"?R=&"+Math.random().toString().substr(2)+"&F="+this.filterServer+"')");
			document.getElementById("rs"+this.name).DataURL+="&F="+this.filterServer
		} 
		if (this.sortServer!="")
			document.getElementById("rs"+this.name).DataURL+="&O="+this.sortServer;
		//window.open().document.writeln(document.getElementById("rs"+this.name).DataURL);
		document.getElementById("rs"+this.name).Reset();
		this.nostart=nostart;
		if (!nostart) {
			this.firstRowSel=this.GetSelectedRowIndex(0,0);
			this.Start();
		} else
			this.firstRowSel=this.GetSelectedRowIndex(this.page,pag);
		this.page=pag;
		this.lastMouseOver=null;
	}

	this.RemoveSmallerEqualBug = function(val) { //this trick is used because of a bug in IE (from 5.0 to 6.0 versions) that consider, for the string type datafield, the smaller equal criterion in filter property like the smaller.
		return val.substr(0,val.length-2) + String.fromCharCode(val.charCodeAt(val.length-2)+1)+'"';
	}


	this.Resize = function(showFilterRow) {
		document.getElementById("div"+this.name).style.overflow="hidden";
		if (showFilterRow+""!="undefined")
			if (showFilterRow)
				document.getElementById("tab"+this.name).rows(1).style.display="";
			else
				document.getElementById("tab"+this.name).rows(1).style.display="none";
		if (this.height!=0) {
			var offset=18;
			if (document.getElementById("div"+this.name).style.height!=(document.getElementById("tab"+this.name).offsetHeight+offset)
				&& ((this.recPageSize!=0 && (params.height+""=="undefined")) || (document.getElementById("tab"+this.name).offsetHeight+offset)<this.height)) {
				document.getElementById("div"+this.name).style.height=document.getElementById("tab"+this.name).offsetHeight+offset;
			} else if (document.getElementById("div"+this.name).style.height!=this.height) {
				document.getElementById("div"+this.name).style.height=this.height;
			}
		}
		document.getElementById("div"+this.name).style.overflow="auto";
	}

	this.RewriteFilter = function(save) {
		var r1=document.getElementById("tab"+this.name).rows(1);
		if (save) this.tempFilter=new Array(r1.cells.length);
		for (var i=0;i<r1.cells.length;i++) {
			if (save) {
				if (r1.childNodes[i].childNodes[0].value+""!="undefined")
					this.tempFilter[i]=r1.childNodes[i].childNodes[0].value;
				else {
					this.tempFilter[i]=r1.childNodes[i].childNodes[0].innerText;
				}
			} else {
				if (this.tempFilter[i]=="Falso" || this.tempFilter[i]=="False") {
					if (this.language=="it")
						r1.childNodes[i].childNodes[0].innerText="Falso";
					else
						r1.childNodes[i].childNodes[0].innerText="False";
				} else if (this.tempFilter[i]=="Vero" || this.tempFilter[i]=="True") {
					if (this.language=="it")
						r1.childNodes[i].childNodes[0].innerText="Vero";
					else
						r1.childNodes[i].childNodes[0].innerText="True";
				} else
					r1.childNodes[i].childNodes[0].value=this.tempFilter[i];
			}
		}
	}

	this.RewriteGrid = function() {
		if (document.getElementById("div" + this.name+"All").style.display=="none") {
			setTimeout(this.name+".RewriteGrid()",500);
			return;
		}
		this.RewriteFilter(true);
		document.getElementById("div"+this.name+"All").innerHTML=this.WriteBar(true)+this.WriteGrid(true);
		this.RewriteFilter(false);
		if (!this.serverSide) {
			this.Start(true);
		} else {
			this.sortServer=this.firstSort;
			this.filterServer="";
			this.sort=this.Server2ClientSort(this.firstSort);
			setTimeout(this.name+".ChangePage(-3,0,true);"+this.name+".PlanSortHeaders()",500);
		}
		this.Resize();
	}

	this.ScrollInto = function() {
		if (this.lastGridScrollLeft==null && lastGridScrollLeft==null) return;
		this.posingGrid=true;
		posingGrid=true;
		if (params.height==0) {
			document.body.scrollLeft=lastGridScrollLeft;
			document.body.scrollTop=lastGridScrollTop;
		} else
			document.getElementById("div"+this.name).scrollLeft=this.lastGridScrollLeft;
		this.posingGrid=false;
		posingGrid=false;
	}

	this.Server2ClientSort = function(field) {
		var ar=field.split(",");
		var s="";
		for (var i=0;i<ar.length;i++) {
			if (s!="") s+=";";
			if (ar[i].toString().charAt(0)=="A")
				s+="+"+this.ArraySort[ar[i].toString().substr(1)][0];
			else
				s+="-"+this.ArraySort[ar[i].toString().substr(1)][1];
		}
		return s;
	}

	this.SetButtonStateNextPrevious = function(pag,lastPag,refresh) {
		if (this.serverSide && this.filterServer!="") {
			if (!this.SetRecordCount(refresh,true)) {
				setTimeout(this.name+".SetButtonStateNextPrevious("+pag+","+lastPag+",false)",500);
				return;
			}
		}
		if (pag==0) {
			this.Toolbar.disable("BackAll");
			this.Toolbar.disable("Back");
			if ((this.serverSide && 
			   ((this.filterServer!="" && Number(eval(this.name+'RecordCountFilter.document.body.outerText'))>this.recPageSize) ||
				(this.filterServer=="" && Number(this.recordCount)>Number(this.recPageSize)))) ||
				!this.serverSide && document.getElementById("rs"+this.name).recordset.recordCount>this.recPageSize) {
				this.Toolbar.enable("Next");
				this.Toolbar.enable("NextAll");
			} else {
				this.Toolbar.disable("Next");
				this.Toolbar.disable("NextAll");
			}
		} else if (pag==lastPag) {
			this.Toolbar.enable("BackAll");
			this.Toolbar.enable("Back");
			this.Toolbar.disable("Next");
			this.Toolbar.disable("NextAll");
		} else {
			this.Toolbar.enable("BackAll");
			this.Toolbar.enable("Back");
			this.Toolbar.enable("Next");
			this.Toolbar.enable("NextAll");
		}
	}

	this.SetCriterion = function(condition) {
		if (this.ArrayFilter[this.lastFilterCol][1]=="N" || this.ArrayFilter[this.lastFilterCol][1]=="D") {
			if (condition==10 || condition==11) {
				this.ArrayCriterions[this.lastFilterCol]=condition + 6;
			} else
				this.ArrayCriterions[this.lastFilterCol]=condition;
		} else if (this.ArrayFilter[this.lastFilterCol][1]=="B") {
				this.ArrayCriterions[this.lastFilterCol]=condition + 18;
				if (condition==0)
					document.getElementById("tab"+this.name).rows(1).childNodes[this.lastFilterCol].childNodes[0].innerHTML="&nbsp;";
				else if (condition==1)
					document.getElementById("tab"+this.name).rows(1).childNodes[this.lastFilterCol].childNodes[0].innerText=this.lang.criterionTrue;
				else if (condition==2)
					document.getElementById("tab"+this.name).rows(1).childNodes[this.lastFilterCol].childNodes[0].innerText=this.lang.criterionFalse;
		} else
			this.ArrayCriterions[this.lastFilterCol]=condition;
		this.posingGrid=true;
		posingGrid=true;
		document.getElementById("tab"+this.name).rows(1).childNodes[this.lastFilterCol].childNodes[0].focus();
		this.posingGrid=false;
		posingGrid=false;
	}

	this.SetMarkedRows = function() {
		if (document.getElementById("tab"+this.name).rows(2)==null ||
			document.getElementById("tab" + this.name).rows(this.firstRowSel+2)==null) {
			setTimeout(this.name+".SetMarkedRows()",500);
			return;
		}
		if (this.lastMouseOver==null || this.lastMouseOver+""=="undefined") 
			this.MouseOverTr(document.getElementById("tab" + this.name).rows(this.firstRowSel+2),false);
		for (var i=2;i<document.getElementById("tab"+this.name).rows.length;i++) {
			var index=i;
			if (this.recPageSize!=0) index+=this.page*this.recPageSize;
			var isMarked=(document.getElementById("tab"+this.name).rows(i).getElementsByTagName('td')[0].getAttribute('bgcolor').toLowerCase()==this.spMark.toLowerCase());
			if (InArray(this.ArrayMarkedRows,index)==-1 && isMarked)
				this.MarkRow(document.getElementById("tab"+this.name).rows(i),false);
			else if (InArray(this.ArrayMarkedRows,index)!=-1 && !isMarked)
				this.MarkRow(document.getElementById("tab"+this.name).rows(i),true);
			else if (i!=this.lastMouseOver.rowIndex)
				setPointer(document.getElementById("tab"+this.name).rows(i), 'out', '#FFFFFF', this.spOver , this.spMark,'#FFFFFF','#000000');
		}
		
	}

	this.SetRecordCount = function(refresh,filter) {
		if (refresh) {
			if (filter) {
				eval(this.name+"RecordCountFilter.location.replace('')");
				eval(this.name+"RecordCountFilter.location.replace('"+this.dataUrl+"?R=&"+Math.random().toString().substr(2)+"&F="+this.filterServer+"')");
			} else {
				eval(this.name+"RecordCount.location.replace('')");
				eval(this.name+"RecordCount.location.replace('"+this.dataUrl+"?R=&"+Math.random().toString().substr(2)+"')");
			}
			return false;
		}
		if (filter) {
			if (eval(this.name+"RecordCountFilter.document.body")==null || eval(this.name+"RecordCountFilter.document.body.outerText")=="") {
				setTimeout(this.name+".SetRecordCount(false,true)",500);
				return false;
			}
			this.recordCountFilter=Number(eval(this.name+"RecordCountFilter.document.body.innerText"));
		} else {
			if (eval(this.name+"RecordCount.document.body")==null || eval(this.name+"RecordCount.document.body.outerText")=="") {
				setTimeout(this.name+".SetRecordCount(false,false)",500);
				return false;
			}
			this.recordCount=Number(eval(this.name+"RecordCount.document.body.innerText"));
		}
		return true;
	}

	this.SetScrollLeft = function() {
		if (!this.posingGrid && !posingGrid) {
			if (params.height==0) {
				lastGridScrollLeft=document.body.scrollLeft;
				lastGridScrollTop=document.body.scrollTop;
			} else {
				this.lastGridScrollLeft=document.getElementById("div"+this.name).scrollLeft;
			}
		}
	}

	this.SetTableInDiv=function() {
		this.tableInDiv=(document.getElementById("div"+this.name).style.posHeight>=(document.getElementById("tab"+this.name).scrollHeight+20));
	}

	this.Show = function() {
		document.getElementById("div"+this.name+"All").style.display="";
		document.getElementById("div"+this.name).style.display="";
		document.getElementById("tab"+this.name).style.display="";
		this.visible=true;
		this.intervalFilterPresent=setInterval(this.name+".CheckFilterPresent()",1000);
		this.OnShow();
	}

	this.ShowCopyright = function() {
		window.open('','',"height=400,width=400,top="+(screen.height-400)/2+",left="+(screen.width-400)/2+",toolbar=no,directories=no,status=no,location=no,menubar=no,resizable=no,scrollbars=no").location.href="grid/Copyright.htm?language="+this.language;
	}

	this.Sort = function(index,first,field,keepMarkedRows) {
		this.lastMouseOver=null;
		if (keepMarkedRows+""=="undefined" || !keepMarkedRows) this.ArrayMarkedRows=new Array();
		if (field+""!="undefined") {
			if (this.serverSide) {
				this.sort=this.Server2ClientSort(field);
			} else
				this.sort=field;
		} else if (!first) {
			if (this.sort.search(this.ArraySort[index][0].toString())==0) {
				this.sort="-"+this.ArraySort[index][1];
			} else if (this.sort.search(this.ArraySort[index][1].toString())==0) {
				this.sort="+"+this.ArraySort[index][0];
			} else {
				var x=this.sort.search(this.ArraySort[index][0].toString());
				var p=this.ArraySort[index][0].toString().length;
				if (x==-1) { 
					x=this.sort.search(this.ArraySort[index][1].toString());
					p=this.ArraySort[index][1].toString().length;
				}
				if (x!=-1) {
					if (this.sort.charAt(x-1)=="+") {
						this.sort=this.sort.substr(0,x-1) +
						"-" + this.ArraySort[index][1] + this.sort.substr(x+p);
					} else if (this.sort.charAt(x-1)=="-") {
						if (this.sort.search(";")!=-1) {
							this.sort=this.sort.substr(0,x-1) + this.sort.substr(x+p+1);
							if (this.sort.charAt(this.sort.length-1)==";")
								this.sort=this.sort.substr(0,this.sort.length-1);
						} else {
							this.sort="+" + this.ArraySort[index][0];
						}
					}
				} else {
					if (this.sort.length!=0) this.sort+=";";
					this.sort+="+"+this.ArraySort[index][0];
				}
			}
		} else {
			var direction;
			if (this.sort.search(this.ArraySort[index][0])==1 && this.sort.charAt(0)=="+")
				direction="-";
			else
				direction="+";
			this.sort=direction;
			if (direction=="+")
				this.sort+=this.ArraySort[index][0];
			else
				this.sort+=this.ArraySort[index][1];
		}
		if (this.serverSide) {
			this.sortServer=this.Client2ServerSort(this.sort);
			this.ReloadData(0);
		} else {
			document.getElementById("rs"+this.name).Sort=this.sort;
			this.PlanSortHeaders();
			document.getElementById("rs"+this.name).Reset();
			setTimeout(this.name+".ChangePage(-3,0)",this.firstDelay);
		}
	}

	this.Start = function(keepMarkedRows) {
		if (document.getElementById("div" + this.name+"All").style.display=="none") {
			setTimeout(this.name+".Start()",500);
			return;
		}
		if (this.recPageSize!=0 && !this.serverSide) {
			if (document.getElementById("rs" + this.name).readyState!=4) {
				setTimeout(this.name+".Start()",this.firstDelay);
				return;
			}
		}
		this.firstRowSel=0;
		if (this.serverSide)
			this.PlanSortHeaders();
		else
			if (document.getElementById("rs"+this.name).Filter=="") this.recordCount=document.getElementById("rs"+this.name).recordset.recordCount;
		if (this.firstSort+""!="undefined" && !this.serverSide) {
			this.Sort('','',this.firstSort,keepMarkedRows);
		} else {
			if (keepMarkedRows+""=="undefined" || !keepMarkedRows) 
				this.ArrayMarkedRows=new Array();
			this.lastMouseOver=null;
			this.ChangePage(-3,0);
		}
	}

	this.UpdateData = function(nochangepage) {
		if (document.getElementById("div" + this.name+"All").style.display=="none") {
			setTimeout(this.name+".UpdateData("+nochangepage+")",500);
			return;
		}
		clearInterval(this.intervalFilterPresent);
		this.ArrayMarkedRows=new Array();
		if (this.canReload) this.Toolbar.disable("Update");
		this.SetRecordCount(true,false);
		if (!nochangepage || this.page==0) this.ChangePage(-3,-1,true);
	}

	this.Write=function() {
		PreloadImg(this);
		this.WriteHeader();
		this.WriteBar();
		this.WriteGrid();
		this.WriteFooter();
		if (this.serverSide) {
			this.sortServer=this.firstSort;
			this.sort=this.Server2ClientSort(this.firstSort);
			if (document.all+""!="undefined" && typeof(window.opera)=="undefined") 
				this.SetRecordCount();
		}
		this.Start();
		if (this.height==0)
			document.body.onscroll=this.SetScrollLeft;
	}
	
	this.WriteBar = function(rewriteAll,rewriteBar) {
		var s="";
		if (document.all+""=="undefined" || typeof(window.opera)!="undefined")
			if (this.language=="it")
				s+="<BR><BR><CENTER><FONT SIZE=3 FACE=Arial>Mi dispiace,<BR>questo script funziona solo con Internet Explorer<BR><BR></CENTER>";				
			else
				s+="<BR><BR><CENTER><FONT SIZE=3 FACE=Arial>I'm sorry,<BR>this script works only with Internet Explorer<BR><BR></CENTER>";	
		
		var params=new Object();
		params.name="bar"+this.name;
		params.buttonSize=this.buttonSize;
		params.grid=this;
		params.buttons=new Array();
		params.imgPath="grid/toolbar/img/";
		var filterOn;
		if (this.canReload) {
			params.buttons=params.buttons.concat(
							[["Update",this.name+".UpdateData()",this.lang.updateData,false,false,false,true]
							,["separator"]]);
			filterOn=(this.filterServer!="");
		} else
			filterOn=(document.getElementById("rs"+this.name).Filter!="");
		if (this.recPageSize!=0) 
			params.buttons=params.buttons.concat(
						    [["BackAll",this.name+".ChangePage(0,-1,true)",this.lang.pageFirst,false,false]
							,["Back",this.name+".ChangePage("+this.name+".page-1,-1,true)",this.lang.pagePrevious,false,false]
							,["Next",this.name+".ChangePage("+this.name+".page+1,-1,true)",this.lang.pageNext,true,false]
							,["NextAll",this.name+".ChangePage(-2,-1,true)",this.lang.pageLast,true,false]
							,["separator"]]);
		if (this.canHelp)
			params.buttons=params.buttons.concat(
							[["Help",this.name+".OnHelp()",this.lang.help,true,false,false,true]
							,["separator"]]);
		params.buttons=params.buttons.concat(
							[["PlanFilter",this.name+".PlanFilter()",this.lang.filterPlan,true,true,false]
							,["ApplyFilter",this.name+".ApplyFilter()",this.lang.filterApply,!filterOn,false]
							,["AvoidFilter",this.name+".AvoidFilter()",this.lang.filterAvoid,filterOn,false]
							,["separator"]
							,["Copyright",this.name+".ShowCopyright()",this.lang.infoCopyright,true,false,false,true]]);
		this.Toolbar=new Toolbar(params);
		if (rewriteBar) return this.Toolbar.Write(false,true);
		if (this.debug && this.serverSide) {
			s+='<DIV ALIGN=RIGHT><FORM ACTION="javascript:'+this.name+'.ChangeRecPageSize()" STYLE="margin:0"><FONT STYLE="font-family:Verdana;font-size:7pt">&nbsp;&nbsp;&nbsp;Recordset PageSize:&nbsp;&nbsp;';
			s+='<INPUT STYLE="font-family:Verdana;font-size:7pt" ID='+this.name+'InputPageSize SIZE=3 VALUE='+this.recPageSize+'>';
			s+='&nbsp;&nbsp;&nbsp;<INPUT TYPE=SUBMIT STYLE="font-family:Verdana;font-size:7pt" TITLE="';
			if (this.language=="it")
				s+='Imposta il numero di record visualizzati alla volta (0=tutti)" VALUE=Imposta>';
			else
				s+='Set the record number showed up at once (0=every)" VALUE=Set>';
			for (var i=0;i<20;i++)
				s+='&nbsp;';
			s+='</FONT></FORM></DIV>';
		} else
			s+="<BR>";
		if (this.buttonSize>=32) s+="<BR>";
		s+='<CENTER>';
		if (rewriteAll) return this.Toolbar.Write(true)+s;
		this.Toolbar.Write();
		document.writeln(s);
	}

	this.WriteFooter = function() {
		var s='</CENTER></DIV>';
		s+='<SCRIPT LANGUAGE=VBSCRIPT>';
		s+='sub popUpFilterCriterion'+this.name+'_Click (byval x)\r';
		s+=this.name+'.SetCriterion (x-1)\r';
		s+=this.name+'.ScrollInto()\r';
		s+='end sub\r';
		s+='</SCR' + 'IPT>';
		document.writeln(s);
	}

	this.WriteGrid = function(rewrite) {
		var s='<DIV onkeydown=' + this.name+ '.CheckTabKey() ID=div'+this.name+' SCROLLBARS=NO onscroll='+this.name+'.SetScrollLeft() STYLE="overflow:hidden';
		if (this.recPageSize==0) s+=";height="+this.height;
		if (this.height!=0) s+=';width=96%';
		s+='">';
		s+='<TABLE onresize="'+this.name+'.Resize()" ID=tab'+this.name+' WIDTH='+this.width+' CELLPADDING=5 CELLSPACING=0 BORDER=1 '+this.gridAttrib +' DATASRC=#rs'+this.name;
		if (this.recPageSize!=0 && !this.serverSide) s+=' DATAPAGESIZE='+this.recPageSize;
		if (this.serverSide) s+=' onreadystatechange="if (this.readyState==\'complete\') '+this.name+'.OnDataReload()"';
		s+='>';
		s+='<THEAD>';
		for (var i=0;i<this.ArrayGrid.length;i++) {
			s+='<TH STYLE="border: 1px inset" BGCOLOR=' + this.ArrayGrid[i][4] + ' WIDTH=' + this.ArrayGrid[i][3] + '>';
			s+='<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>';
			s+='<TR><TH oncontextmenu="'+this.name+'.NoContext()">';
			s+='<FONT ' + this.headerFontAttrib + ' STYLE="cursor:hand;' + this.headerFontStyle + '" oncontextmenu="' +this.name + '.NoContext()" onmousedown="'+this.name+'.MouseDownTh('+i+')" onmouseover="window.status=\''+this.ArrayGrid[i][6]+'\'" onmouseout="window.status=\'\'">';
			s+=this.ArrayGrid[i][0];
			s+='<TD ALIGN=CENTER><IMG ALIGN=middle ID=img'+this.name+this.ArraySort[i][0]+' SRC=grid/img/white.gif BORDER=0 VSPACE=0 HSPACE=5>';
			s+='<DIV ID=divSortNum'+this.name+this.ArraySort[i][0]+' STYLE="display:none"></DIV>';
			s+='</TABLE>';
		}
		s+='<TR BGCOLOR='+this.filterBgColor+' STYLE="display:none">';
		for (var i=0;i<this.ArrayGrid.length;i++) {		
			s+='<TD STYLE="border: 1px inset" ondblclick="'+this.name+'.DblclickTd('+i+')"';
			if (this.ArrayGrid[i][2].charAt(0)=="B")
				s+=' onselectstart="return false"><SPAN STYLE="'+this.filterFontStyle+'border:none;background-color:'+this.filterBgColor+'">&nbsp;</SPAN>';
			else
				s+='><INPUT onkeypress='+this.name+'.KeyPressFilter() SIZE=1 STYLE="'+this.filterFontStyle+'border:none;background-color:'+this.filterBgColor+'">';
			
		}		
		s+='</TR>';
		s+='</THEAD>';
		s+='<TBODY>';
		s+='<TR onmouseover="'+this.name+'.MouseOverTr(this,true)" onclick="'+this.name+'.ClickTr(this)">';
		for (var i=0;i<this.ArrayGrid.length;i++) {
			s+='<TD BGCOLOR=' + this.ArrayGrid[i][5] + ' ID=td' + this.name+i;
			if (this.ArrayGrid[i][2].charAt(0)=="B")					
				s+=' ALIGN=CENTER><INPUT TYPE=CHECKBOX onclick="' + this.name+'.NoContext()" DATAFLD='+this.ArrayGrid[i][1]+' onmousedown="'+this.name+'.ClickCheck(this)">';
			else {
				if (this.ArrayGrid[i][7]+""!="undefined" && this.ArrayGrid[i][7]!=null)
					s+=' ALIGN='+this.ArrayGrid[i][7];
				if (this.ArrayGrid[i][2].charAt(0)=="I") {
					s+='><IMG onmouseover="'+this.name+'.MouseOverSpan(this);'+this.name+'.OnMouseOverSpan(this)" DATAFLD='+this.ArrayGrid[i][1]+' onmousedown="'+this.name+'.ClickImg(this)"';
					if (this.ArrayGrid[i][2].charAt(1)=="L")
						s+=' STYLE="cursor:hand" onclick="'+this.name+'.OnClickSpan(this);'+this.name+'.NoContext()"';
					s+='>';
				} else {
					s+='><FONT COLOR=';
					if (this.ArrayGrid[i][8]+""!="undefined" && this.ArrayGrid[i][8]!=null)
						s+=this.ArrayGrid[i][8];
					else
						s+=this.gridFontColor;
					s+=" "+this.gridFontAttrib;
					s+=' STYLE="';
					if (this.ArrayGrid[i][9]+""!="undefined" && this.ArrayGrid[i][9]!=null) 
						s+=this.ArrayGrid[i][9]+";";
					s+=this.gridFontStyle;
					s+='">&nbsp;<SPAN';
					if (this.ArrayGrid[i][2].charAt(1)=="L")
						s+=' STYLE="cursor:hand" onclick="'+this.name+'.OnClickSpan(this);'+this.name+'.NoContext()"';

					s+=' onmouseover="'+this.name+'.MouseOverSpan(this);'+this.name+'.OnMouseOverSpan(this)" DATAFLD='+this.ArrayGrid[i][1]+' onmousedown="'+this.name+'.ClickSpan(this)"></SPAN></FONT>';
				}
			}
		}
		s+='</TBODY>';
		s+='</TABLE>';
		s+='</DIV>';
		//window.open().document.writeln("<PLAINTEXT>"+s);
		if (rewrite) return s;
		document.writeln(s);
	}

	this.WriteHeader = function() {
		var s='<OBJECT classid="clsid:333C7BC4-460F-11D0-BC04-0080C7055A83" ID=rs' + this.name + ' HEIGHT=0 WIDTH=0';
		if (this.serverSide) s+=' ondatasetcomplete="if (this.reason==0) '+this.name+'.OnDataLoad()"';
		s+='><PARAM NAME="DataURL" VALUE="'+this.dataUrl
		if (this.serverSide) s+="?O="+this.firstSort+"&P=0&S="+this.recPageSize;
		s+='">';
		s+='<PARAM NAME="UseHeader" VALUE="True">';
		if (this.textQualifier=="'")
			s+='<PARAM NAME="TextQualifier" VALUE="\'">';
		else
			s+='<PARAM NAME="TextQualifier" VALUE=\'' + this.textQualifier +'\'>';
		s+='<PARAM NAME="CaseSensitive" VALUE="false">';
		s+='</OBJECT>';
		s+='<OBJECT classid="clsid:7823A620-9DD9-11CF-A662-00AA00C066D2" ID=popUpFilterCriterion' + this.name + ' width=0 height=0 codebase="http://activex.microsoft.com/controls/iexplorer/x86/iemenu.cab#version=4,71,115,0"></OBJECT>';
		if (this.serverSide) {
			s+='<IFRAME onreadystatechange="if (this.readyState==\'complete\') '+this.name+'.SetRecordCount(false,false)" SRC="'+this.dataUrl+'?R=" WIDTH=0 HEIGHT=0 ID='+this.name+'RecordCount></IFRAME>';
			s+='<IFRAME onreadystatechange="if (this.readyState==\'complete\') '+this.name+'.SetRecordCount(false,true)" WIDTH=0 HEIGHT=0 ID='+this.name+'RecordCountFilter></IFRAME>';
		}
		s+='<DIV ID=div' + this.name + 'All STYLE="overflow:scroll';
		if (!this.visible)
			s+=';display:none';
		else
			this.intervalFilterPresent=setInterval(this.name+".CheckFilterPresent()",1000);
		s+='">';
		document.writeln(s);
	}

	this.Write();
}

//this variables are used for pages with a "params.height = 0" grid header script or more;
//they are useful to keep the whole page scrollbars alignment during the grid operation of filter planing-applying-avoiding, sort planing, data-pages changing and data updating.
var lastGridScrollLeft;
var lastGridScrollTop;
var posingGrid;