//see "Visits.js" file to obtain the grid parameters' configuration

var itArrayGridSmiles=[["ID","id","N","5%","#FF6600","White","Ordina per l\\\' ID","RIGHT","#333366",null,"YELLOW","font-weight:bold"],
		    		   ["Codice","code","S","15%","#FF6600","White","Ordina per il codice","CENTER","GREEN","font-weight:bold",null,"font-weight:bold"],
					   ["Immagine","smile_url","IL","10%","#FF6600","White","Ordina per l\\\' immagine","CENTER"],
				       ["Emozione","emotion","S","30%","#FF6600","White","Ordina per l\\\' emozione","CENTER","#CC0000",null,null,"font-variant:small-caps"],
					   ["Attiva","active","B","10%","#FF6600","White","Ordina per lo stato di attivit","CENTER"],
					   ["Data emissione","date","D","30%","#FF6600","White","Ordina per la data di emissione","RIGHT","#336699","font-style:italic",null,"font-style:italic"]];
var enArrayGridSmiles=CopyArray(itArrayGridSmiles);
enArrayGridSmiles[0][6]="Order by ID";
enArrayGridSmiles[1][0]="Code";
enArrayGridSmiles[1][6]="Order by code";
enArrayGridSmiles[2][0]="Image";
enArrayGridSmiles[2][6]="Order by image";
enArrayGridSmiles[3][0]="Emotion";
enArrayGridSmiles[3][6]="Order by emotion";
enArrayGridSmiles[4][0]="Active";
enArrayGridSmiles[4][6]="Order by active state";
enArrayGridSmiles[5][0]="Issue date";
enArrayGridSmiles[5][6]="Order by issue date";

function Smiles_init() {
	params=new Object();
	params.name="Smiles";
	params.headerFontStyle="font-size:9pt";
	params.headerFontAttrib="FACE=Arial COLOR=#F4FAFF";
	params.gridFontAttrib="FACE=Comic";
	params.rowOverBgColor="#FFFF33";
	params.rowMarkBgColor="#CC0033";
	params.filterBgColor="#F0F0F0";
	params.visible=false;
	params.ArrayGrid=eval(GetLang()+"ArrayGridSmiles");
	params.ArrayFilter=[["id","N"],["code","S"],["smile_url","S"],["emotion","S"],["active","B"],["date","D"]];
	params.ArraySort=[["id","id"],["code","code"],["smile_url","smile_url"],["emotion","emotion"],["active","active"],["date","date"]];
	params.recPageSize=8;
	params.OnClickSpan=OnClickSpan;
	params.OnMouseOverSpan=OnMouseOverSpan;
	params.serverSide="PHP";
	if (params.serverSide) {
		params.firstSort="A0";
	} else {
		params.firstSort="+id";
	}
	Smiles=new Grid(params);
}

var win;

function OnClickSpan(ele) {
	if (ele.dataFld=="smile_url" && !Smiles.filterVisible) {
		var h=30;
		var w=150;
		if (win==null || win.closed || win.document.body==null) {
			win=window.open("",null,"width="+w+", height="+h+", copyhistory=no, toolbar=no, location=no, menubar=no, status=no, scrollbars=no, resizable=no, top="+(screen.height-h)/2+", left="+(screen.width-w)/2);
			win.document.body.topMargin=23;
		}
		win.document.body.innerHTML="<CENTER><IMG WIDTH=50 HEIGHT=50 SRC="+ele.src+" ALT='"+GetImgName(ele)+"'></CENTER>";
		win.focus();
	}
}

function OnMouseOverSpan(ele) {
	if (ele.dataFld=="smile_url") {
		ele.title=GetImgName(ele);
	}
}

function GetImgName(ele) {
	return ele.src.substr(ele.src.lastIndexOf("/")+1,ele.src.length-ele.src.lastIndexOf("/")-5);
}

Smiles_init();